/***************************************************************************
                          attribute_line_edit.h  -  description
                             -------------------
    begin                : Tue Apr 23 2002
    copyright            : (C) 2002 by Volker Nannen
    email                : volker@nannen.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ATTRIBUTE_LINE_EDIT_H
#define ATTRIBUTE_LINE_EDIT_H

#include "attribute.h"

class QLineEdit;
class QValidator;

//--------------------------------------Attribute_line_edit
class Attribute_line_edit: public Attribute{
  Q_OBJECT

public:
  Attribute_line_edit(const int ID, Attribute * parent, QString name,
                      QString value=QString::null,
                      BasicElement::EditMode edit = BasicElement::SHOW);
  virtual void createEditor();
  virtual void createValidator(){;}
  virtual void hideEditor();

public slots:
  virtual void resetProperty();
  virtual void returnPressed();

protected:
  QValidator * validator;
  QLineEdit * lineEdit;
};
//--------------------------------------Attribute_int
class Attribute_int: public Attribute_line_edit{
  Q_OBJECT

public:
  Attribute_int(const int ID, Attribute * parent, QString name ,
                int & val, const int & def,
                BasicElement::EditMode edit = BasicElement::SHOW);
  virtual void createValidator();

public slots:
  virtual void returnPressed();
  virtual void valueChanged();

private:
  int &val;
  int def;
};
//--------------------------------------Attribute_double
class Attribute_double: public Attribute_line_edit{
  Q_OBJECT

public:
  Attribute_double(const int ID, Attribute * parent, QString name ,
                   double & val, const double & def,
                   BasicElement::EditMode edit = BasicElement::SHOW);
  virtual void createValidator();

public slots:
  virtual void returnPressed();
  virtual void valueChanged();

private:
  double &val;
  double def;
};
//--------------------------------------Attribute_qstring
class Attribute_qstring: public Attribute_line_edit{
  Q_OBJECT

public:
  Attribute_qstring(const int ID, Attribute * parent, QString name ,
                    QString & val, const QString def,
                    BasicElement::EditMode edit = BasicElement::SHOW);

public slots:
  virtual void returnPressed();
  virtual void valueChanged();

private:
  QString &val;
  QString def;
};

#endif
