/***************************************************************************
                          basicelement.h  -  description
                             -------------------
    begin                : Fri Jan 10 2003
    copyright            : (C) 2003 by Volker Nannen
    email                : volker@nannen.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef BASICELEMENT_H
#define BASICELEMENT_H

#include "basicitem.h"
#include "xml_element.h"

#include <iostream>

using namespace std;

class Collection;
class QDomElement;

class BasicElement : public BasicItem, public XML_Element {

public:
  BasicElement(const int ID=0, const QString elementName = "basicElement");
  virtual ~BasicElement();
  virtual const QString tagName() const { return "BasicElement"; }

  int getID()                                              { return BasicItem::getID(); }
  virtual void setID(const int newID);
  virtual void setValid(const bool yes=true);
  virtual void toggleColor(const bool yes=true);

  virtual void mousePressed(const QMouseEvent * event);
  virtual void mouseDoubleClicked(const QMouseEvent * event);  
  virtual void mouseMoved(const QMouseEvent * event);
  virtual void mouseReleased(const QMouseEvent * event);

  void setParentCollection(Collection * newParent)         { parentCollection = newParent; }

protected:
  virtual void xml_list();

  Collection * getParentCollection()                       { return parentCollection; }

protected:
  bool valid;
  
private:
  Collection * parentCollection;
  
};


#endif
