/***************************************************************************
                          collection.h  -  description
                             -------------------
    begin                : Fri May 3 2002
    copyright            : (C) 2002 by Volker Nannen
    email                : volker@nannen.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef COLLECTION_H
#define COLLECTION_H

#include "basicelement.h"

#include <vector>

using namespace std;

class Collection : public vector<BasicElement * > {
public:
  Collection(const char * name = 0);
  ~Collection();

public:
  int push_back(BasicElement *);
  int & getCount()                                       { return elementCount; }

  QString IDToName(const int ID);
  BasicElement * operator[](const int ID)              { return IDToElement(ID); }
  BasicElement * IDToElement(const int ID);
  int IndexToID(const int index);
  int IDToIndex(const int ID);
  int elementToID(BasicElement * element);
  void remove(const int ID);

private:
  const char * name;
  int elementCount;
  BasicElement * elementToDestroy;
};

#endif
