/***************************************************************************
                          data.cpp  -  description
                             -------------------
    begin                : Sun Mar 10 2002
    copyright            : (C) 2002 by Volker Nannen
    email                : volker@nannen.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "data.h"

#include <qstring.h>

#include <cmath>
#include <cstdlib>
#include <iostream>

using namespace std;

QString boolToQString(const bool & yes){
	return (yes ? "true" : "false");
}
bool QStringToBool(const QString & yes){
	return(yes.lower() == "true");
}
double gaussianNoise(double sigma){
  static bool second(false);
  static double y2;
  static double div(2.0 / RAND_MAX);
  if(second){
    second = false;
    return sigma * y2;
  } else {
    second = true;
    float x1, x2, w; 
    do {
      x1 = rand() * div - 1.0;
      x2 = rand() * div - 1.0;
      w = x1 * x1 + x2 * x2;
    } while ( w >= 1.0 );
    w = sqrt( (-2.0 * log( w ) ) / w );
    y2 = x2 * w;
    return sigma * x1 * w;
  }
}
double cauchyNoise(double cauchyA, double cauchyB){ //  pi = 3.141592654
  static double div( /*6.28318530*/ 3.14159265 / RAND_MAX);
  return cauchyB * tan ( rand() * div - 1.570796327 ) - cauchyA;
}
double exponentialNoise(double lambda){
  static double div(2.0 / RAND_MAX);
  double result;
  bool negative = true;
  do {
    result = rand() * div;
//  cerr << " exp rand " << result << endl;
    if( result > 1 ) {
      negative = false;
      result -= 1;
    }
  } while ( ! result );
  result = log( result );
  if ( lambda ) result /= lambda;
  if ( negative ) result = -result;
  return result;
}
double uniformNoise(double lowerLimit, double upperLimit){
  static double div(1.0 / RAND_MAX);
//  cerr << " lower " << lowerLimit << "\t\t upper " << upperLimit << endl;
  return ( rand() * div * (upperLimit - lowerLimit) ) + lowerLimit;
}

