/***************************************************************************
                          statisticaldataviewer.h  -  description
                             -------------------
    begin                : Wed Jan 15 2003
    copyright            : (C) 2003 by Volker Nannen
    email                : volker@nannen.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef STATISTICALDATAVIEWER_H
#define STATISTICALDATAVIEWER_H

#include <qmainwindow.h>

#include <vector>

using namespace std;

class Project;
class SDVStatusBar;
class BasicElement;
class GraphEditor;

class QPopupmenu;
class QCanvas;
class QSplitter;
class Workspace;

class StatisticalDataViewer : public QMainWindow  {
  Q_OBJECT

public:
  StatisticalDataViewer(QWidget * parent=0, const char * name=0, WFlags f=0);
  ~StatisticalDataViewer();

private:
  void makeProject();

private slots:
  void newProject();
  void openProject();
  void saveProject();
  void closeProject(Project * deadProject=0);
  void selectProject(int index);
  void savePlot();
  void addProcess();
  void addPolynomial();
//  void addNeural();
  void addSample();
  void addSplit();
  void fillProjectMenu();

  void toggleAnimated();
  void help();
//  void test();
  void toggleDoubleBuffer();
  void tile();
  void cascade();
  void windowActivated(QWidget * newPlot);

private:
  void destroy();
  void makeMenus();

public:
  const char * name;

private:
//  QPopupMenu * optionsMenu;
  QPopupMenu * viewMenu;
  QPopupMenu * projectMenu;
  SDVStatusBar * statusBar;
  int dblBufferID;
  int animatedID;
  GraphEditor * graphEditor;
  vector<Project *> projects;
  Project * currentProject;
  QSplitter * centralFrame;
  Workspace * workspace;
};


#endif
