/***************************************************************************
                          domenumeration.h  -  description
                             -------------------
    begin                : Mon Apr 29 2002
    copyright            : (C) 2002 by Volker Nannen
    email                : volker@nannen.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DOMENUMERATION_H
#define DOMENUMERATION_H

#include <qstring.h>

#include <vector>

using namespace std;

class BasicElement;

//------------------------------DomEnumerationItem

class DomEnumerationItem {
public:
  DomEnumerationItem(QString string=QString::null, int index=-1);

public:
  QString string;  // name in the ComboBox
  int value;       // for enumerations, for collections it is the ID
};

//------------------------------DomEnumeration

class Collection;

class DomEnumeration {
public:
  DomEnumeration(QString name = QString::null);
  ~DomEnumeration();
  void init(Collection * newCollection, const QString newCriterion=QString::null);
  void add(Collection * newCollection, const QString newCriterion=QString::null);
  void removeID(const int ID);
  
public:
  bool operator()(const QString newString, const int newValue=-1)  { return insert(newString, newValue); }
  bool insert(const QString newString, const int newValue=-1);
  int size() const                                         { return contents.size(); }
  void clear()                                             { contents.clear(); }

  QString stringAtValue(const int & value);
  QString stringAtIndex(const int & index) const;

  int valueAtString(const QString & string);
  int valueAtIndex(const int & index) const;

  int indexOfValue(const int & value) const;
  int indexOfString(const QString & string) const;

  BasicElement * elementAtIndex(const int & index) const;
  BasicElement * elementAtValue(const int & value) const;

private:
  vector<DomEnumerationItem> contents;
  QString name;
  QString criterion;
  Collection * collection;
};

#endif
