/***************************************************************************
                          enhancedprogressbar.cpp  -  description
                             -------------------
    begin                : Wed Jan 15 2003
    copyright            : (C) 2003 by Volker Nannen
    email                : volker@nannen.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "enhancedprogressbar.h"

#include <qapplication.h>

#include <iostream>

using namespace std;

EnhancedProgressBar::EnhancedProgressBar(EnhancedProgressBar * other, 
                             QString message,
                             int limit,
                             const int minimumDuration)
  : ownDialog( other ? false : true )
{
  if( other ){
    dialog = other->dialog;
    oldText = dialog->labelText();
    oldSteps = dialog->totalSteps();
    oldProgress = dialog->progress();
    dialog->setProgress(0);
    dialog->setTotalSteps(limit);
    dialog->setLabelText(oldText + " "
                         + QString::number(
                             int( oldSteps ? 100*oldProgress/oldSteps : 0 ) )
                         + "%" + "<br>" + message);
  } else {
    dialog =  new QProgressDialog(message, "Abort", limit, qApp->mainWidget(), 
              "progress"),
    dialog->setCaption("SDV progress bar");
    init(minimumDuration);
  }
}
EnhancedProgressBar::EnhancedProgressBar(QString message, 
                             const int limit,
                             const int minimumDuration)
  : ownDialog(true),
    dialog( new QProgressDialog(message, "Abort", limit, qApp->mainWidget(), 
            "progress") )
{
  init(minimumDuration);
}
EnhancedProgressBar::~EnhancedProgressBar(){
  if( ownDialog ) {
    delete dialog;
    dialog = 0;
  } else {
    dialog->setProgress(oldProgress);
    dialog->setTotalSteps(oldSteps);
    dialog->setLabelText(oldText);
  }
}
void EnhancedProgressBar::init(const int duration){
  dialog->setMinimumDuration(duration);
  dialog->setAutoClose(false);
  if( ! duration ) check(1);
}
bool EnhancedProgressBar::check(){
  qApp->processEvents();
  return dialog->wasCancelled();
}
bool EnhancedProgressBar::check(const int counter){
  dialog->setProgress(counter);
  qApp->processEvents();
  return dialog->wasCancelled();
}
