/***************************************************************************
                          grapheditor.h  -  description
                             -------------------
    begin                : Thu Dec 19 2002
    copyright            : (C) 2002 by Volker Nannen
    email                : volker@nannen.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GRAPHEDITOR_H
#define GRAPHEDITOR_H

#include "project.h"

#include <qsplitter.h>

class QListBox;
class GraphEditView;
class QResizeEvent;
class Collection;

class GraphEditor : public QSplitter {
  Q_OBJECT

public:
  GraphEditor(QWidget * parent = 0, const char * name = 0);

public:
  void setProject(Project * newProject);
//  void testDom(QDomElement * element, int indent=2);
  virtual void resizeEvent( QResizeEvent * e ); // overridden

public slots:
  void elementSelected(int index);      // by the list box
  void elementHighlighted(int index);   // by the list box
  Collection * graphs()                                 { return project->getGraphs(); }
  void fillListBox();
  void fillGraphView(int ID=0);
//  void highlight(int index=0);

private:
  QListBox * graphList;
  GraphEditView * graphView;
  Project * project;
};

#endif
