/***************************************************************************
                          grapheditview.cpp  -  description
                             -------------------
    begin                : Tue Apr 23 2002
    copyright            : (C) 2002 by Volker Nannen
    email                : volker@nannen.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "grapheditview.h"
#include "attribute.h"
#include "project.h"

GraphEditView::GraphEditView(QWidget * parent, const char * name)
  : QListView(parent, name),
    activeItem(0),
    disposible(true)
{
  setRootIsDecorated(true);
  connect(this, SIGNAL(selectionChanged(QListViewItem *)), this, SLOT(itemSelected(QListViewItem*)));
}
GraphEditView::~GraphEditView(){
}
void GraphEditView::clear(){
  if(activeItem){
    activeItem->hideEditor();
    activeItem=0;
  }
  if(disposible){
//    cerr << " --------- disposible\n";
    QListView::clear();
  } else {
//    cerr << " -- not -- disposible\n";
    firstChild()->setVisible(false);
  }
}
void GraphEditView::itemSelected(QListViewItem * newItem){
  if(activeItem){
    activeItem->hideEditor();
  }
  activeItem = dynamic_cast<Attribute*>(newItem);
  activeItem->showEditor();
}
void GraphEditView::refresh(const int ID){
  project->refreshElement(ID);
}
