/***************************************************************************
                          grapheditview.h  -  description
                             -------------------
    begin                : Tue Apr 23 2002
    copyright            : (C) 2002 by Volker Nannen
    email                : volker@nannen.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GRAPHEDITVIEW_H
#define GRAPHEDITVIEW_H

#include <qlistview.h>

class Attribute;
class QListViewItem;
class Project;

class GraphEditView : public QListView  {
  Q_OBJECT

public: 
  GraphEditView(QWidget * parent, const char * name);
  ~GraphEditView();
  void clear();
  void refresh(const int ID);
  void setProject(Project * newProject)                   { project = newProject; }
  void setDisposible(const bool dispo)                    { disposible = dispo; }
  bool getDisposible() const                              { return disposible; }

public slots:
  void itemSelected(QListViewItem * newItem);//itemSeleted(QListViewItem * newItem);

private:
  Attribute * activeItem;
  Project * project;
  bool disposible;
};

#endif
