/***************************************************************************
                          learnpolynomial.h  -  description
                             -------------------
    begin                : ?' ??? 5 2002
    copyright            : (C) 2002 by Volker Nannen
    email                : volker@nannen.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef LEARNPOLYNOMIAL_H
#define LEARNPOLYNOMIAL_H

#include "polynomial.h"

class LearnPolynomial : public Polynomial  {

public:
  LearnPolynomial(Project * project, const QString name="polynomial", QDomElement * element=0);
  LearnPolynomial(LearnPolynomial * other);

  virtual void refresh();
  virtual Graph * copyGraph()                          { return new Polynomial(this); }

private:
  bool learn();
  bool crossValidate(Sample * sample);
  bool two_part_MDL(Sample * sample);
  bool trimmed_MDL(Sample * sample);
  bool mixture_MDL(Sample * sample);
  bool complexAnalysis(Sample * sample);
  bool analysis(Sample * sample);
  bool orderPrecision(Sample * sample);
  double gamma(const int m, const int n, const int d, const double a1, const double a2);
  void smooth(double * array, const int size, const int step=1);

  bool noPlot();
  bool noTest();
  bool noMatrix();
  bool emptyTest();
  bool noTestProcess();
  
};

#endif
