/***************************************************************************
                          scientificcanvas.h  -  description
                             -------------------
    begin                : Wed Jan 15 2003
    copyright            : (C) 2003 by Volker Nannen
    email                : volker@nannen.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SCIENTIFICCANVAS_H
#define SCIENTIFICCANVAS_H

#include "basicelement.h"
#include "axes.h"

#include <qcanvas.h>

#include <vector>

using namespace std;

class Axes;
class Project;
class Plot;
class Points;
class ScientificCanvas;
class QDomElement;

//------------------------------class ScientificCanvasZoom

class ScientificCanvasZoom : public QCanvasRectangle, public BasicItem {
public:
  ScientificCanvasZoom(const int ID, ScientificCanvas * canvas);
};


//------------------------------class ScientificCanvas

class ScientificCanvas : public QCanvas, public BasicElement {

public:
  ScientificCanvas(Project * project, const QString name,
              QDomElement * element=0);
  ScientificCanvas(ScientificCanvas * canvas, const QString name);
  ~ScientificCanvas();
  virtual const QString tagName() const { return "Canvas"; }

public: // overridden
  virtual bool xml_write(QDomElement * parent);
  virtual bool xml_read(QDomElement * element);
  virtual void xml_list();
  virtual void refresh();
  virtual void toggleColor(const bool yes= true);
  virtual void setValid(const bool yes=true);
  virtual void setID(const int newID);

  virtual void mousePressed(const QMouseEvent * event);
  virtual void mouseMoved(const QMouseEvent * event);
  virtual void mouseReleased(const QMouseEvent * event);

  Axes * getAxes()                                      { return & axes; }
  void setAxesVisible(bool yes=true);
  void setAnimated(bool yes);
  void setFocus();
  void clear();
  Project * getProject() const                          { return project; }
  void setSize(const int & width, const int & height);
  Points * getNewPoints(const int ID=0, const QString color="black");
  void makePrincipal(const bool & yes=true)             { principal = yes; }
  void emitValueChanged()                               { emit valueChanged(); }
  bool close();
  void setCaption(const QString newCaption);
  void test(const double number);

private:

  void destroy();
  void init();

private:
  QString caption;
  bool principal;
  bool mouseLocked;
  Project * project;
  Axes axes;
  Plot * plot;
  ScientificCanvasZoom zoom;
  int canvasWidth, canvasHeight;
  int margin, controlMargin;
  QString bgColor;
  vector<Points *> screenPoints;
  int zoomX, zoomY;
  int newZoomX, newZoomY;
};


#endif
