/***************************************************************************
                          selectionmethod.cpp  -  description
                             -------------------
    begin                : Tue Dec 31 2002
    copyright            : (C) 2002 by Volker Nannen
    email                : volker@nannen.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "selectionmethod.h"
#include "points.h"
#include "scientificcanvas.h"

#include "qdom.h"

SelectionMethod::SelectionMethod(const int ID, const QString name,
                                 QDomElement * /*element*/)
  : BasicElement(ID, name)
{
  hideName();
//  canvas = new ScientificCanvas(project, getElementName() + " screen");
  canvas->setSize(300, 300);
//  canvas->setCaption(project->getElementName() + "::" + getElementName() );
}
SelectionMethod::~SelectionMethod(){;}

/*void SelectionMethod::xml_list(){
  BasicElement::xml_list();
}
void SelectionMethod::xml_read(QDomElement * element){
  if(element){
    QDomNodeList nodeList = element->elementsByTagName("Graph");
    for(int i=0; i<nodeList.count(); i++){
      Points * points = getNewPoints();
      QDomElement myElement = nodeList.item(i).toElement();
      points->xml_read( & myElement );
      points->recalculate();
    }
  }
}
Points * SelectionMethod::getNewPoints(const int ID, const QString color){
  Points * newPoints = new Points(0, canvas);
  newPoints->setID( ID ? ID : getID() );
  newPoints->setContinuous(true);
  newPoints->setVisible(true);
  newPoints->setColor(color);
//  newPoints->setPreserve(true);
//  screenPoints.push_back(newPoints);
  return newPoints;
}*/

//-------------------------------------------------class TwoPartMDLMethod

TwoPartMDLMethod::TwoPartMDLMethod(const int ID, QDomElement * element)
  : SelectionMethod(ID, "selectionMethod", element)
{
  xml_read(element);
}
void TwoPartMDLMethod::xml_list(){
  SelectionMethod::xml_list();
}

//-------------------------------------------------class MixedMDLMethod

MixedMDLMethod::MixedMDLMethod(const int ID, QDomElement * element)
  : SelectionMethod(ID, "selectionMethod", element)
{
  xml_read(element);
}
void MixedMDLMethod::xml_list(){
  SelectionMethod::xml_list();
}

//-------------------------------------------------class TrimmedMDLMethod

TrimmedMDLMethod::TrimmedMDLMethod(const int ID, QDomElement * element)
  : SelectionMethod(ID, "selectionMethod", element)
{
  xml_read(element);
}
void TrimmedMDLMethod::xml_list(){
  SelectionMethod::xml_list();
}

//-------------------------------------------------class CrossValidationMethod

CrossValidationMethod::CrossValidationMethod(const int ID, QDomElement * element)
  : SelectionMethod(ID, "selectionMethod", element)
{
  xml_read(element);
}
void CrossValidationMethod::xml_list(){
  SelectionMethod::xml_list();
}

//-------------------------------------------------class AnalysisMethod

AnalysisMethod::AnalysisMethod(const int ID, QDomElement * element)
  : SelectionMethod(ID, "selectionMethod", element)
{
  xml_read(element);
}
void AnalysisMethod::xml_list(){
  SelectionMethod::xml_list();
}

//-------------------------------------------------class ComplexAnalysisMethod

ComplexAnalysisMethod::ComplexAnalysisMethod(const int ID, QDomElement * element)
  : SelectionMethod(ID, "selectionMethod", element)
{
  xml_read(element);
}
void ComplexAnalysisMethod::xml_list(){
  SelectionMethod::xml_list();
}

//-------------------------------------------------class OrderPrecisionMethod

OrderPrecisionMethod::OrderPrecisionMethod(const int ID, QDomElement * element)
  : SelectionMethod(ID, "selectionMethod", element)
{
  xml_read(element);
}
void OrderPrecisionMethod::xml_list(){
  SelectionMethod::xml_list();
}

