/***************************************************************************
                          Selectionmethod.h  -  description
                             -------------------
    begin                : Tue Dec 31 2002
    copyright            : (C) 2002 by Volker Nannen
    email                : volker@nannen.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SELECTIONMETHOD_H
#define SELECTIONMETHOD_H

#include "basicelement.h"

#include <qstring.h>

class QDomElement;
class Points;
class ScientificCanvas;
class Polynomial;

class SelectionMethod : public BasicElement  {
public:
  SelectionMethod(const int ID=0, const QString elementName=0, QDomElement * element=0);
  ~SelectionMethod();

public:
//  virtual bool xml_read(QDomElement * element=0);
//  virtual void xml_list();
//  Points * getNewPoints(const int ID=0, const QString color="black");

protected:

private:
  ScientificCanvas * canvas;
};

//-------------------------------------------------class TwoPartMDLMethod

class TwoPartMDLMethod: public SelectionMethod {
public:
  TwoPartMDLMethod(const int ID=0, QDomElement * element = 0);

public:
  virtual void xml_list();

private:

};

//-------------------------------------------------class MixedMDLMethod

class MixedMDLMethod: public SelectionMethod {
public:
  MixedMDLMethod(const int ID=0, QDomElement * element = 0);

public:
  virtual void xml_list();

private:

};


//-------------------------------------------------class TrimmedMethod

class TrimmedMDLMethod: public SelectionMethod {
public:
  TrimmedMDLMethod(const int ID=0, QDomElement * element = 0);

public:
  virtual void xml_list();

private:

};

//-------------------------------------------------class CrossValidationMethod

class CrossValidationMethod: public SelectionMethod {
public:
  CrossValidationMethod(const int ID=0, QDomElement * element = 0);

public:
  virtual void xml_list();

private:

};

//-------------------------------------------------class AnalysisMethod

class AnalysisMethod: public SelectionMethod {
public:
  AnalysisMethod(const int ID=0, QDomElement * element = 0);

public:
  virtual void xml_list();

private:

};

//-------------------------------------------------class ComplexAnalysisMethod

class ComplexAnalysisMethod: public SelectionMethod {
public:
  ComplexAnalysisMethod(const int ID=0, QDomElement * element = 0);

public:
  virtual void xml_list();

private:

};

//-------------------------------------------------class OrderPrecisionMethod

class OrderPrecisionMethod: public SelectionMethod {
public:
  OrderPrecisionMethod(const int ID=0, QDomElement * element = 0);

public:
  virtual void xml_list();

private:

};
#endif
