/***************************************************************************
                          split.h  -  description
                             -------------------
    begin                : ?' ??? 6 2002
    copyright            : (C) 2002 by Volker Nannen
    email                : volker@nannen.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SPLIT_H
#define SPLIT_H

#include "graph.h"
#include "domenumeration.h"


class Split : public Graph  {
public: 
  Split(Project * project, const QString name="split", QDomElement * element=0);
  ~Split();
  virtual const QString tagName() const { return "Split"; }

public:
  virtual bool xml_read(QDomElement * element);
  virtual void xml_list();
  virtual void refresh();

private:
  void makeControl();
  void init();
  void destroy();
  bool splitSample();
  int makeSample(QString name, QString color);

private:
  enum Method {
    PERCENT,
    NUMBER
  };

private:
  class MethodEnumeration : public DomEnumeration{
    public: MethodEnumeration();
  };
  static MethodEnumeration methodEnumeration;
  int method, controlMethod;
  DomEnumeration * sampleEnumeration, * splitEnumeration;
  int splitSampleID, controlSplitSampleID;
  int sample_1_ID, sample_2_ID;
  double percent, controlPercent, dummyPercent;
  int number, controlNumber;
  bool split, controlSplit;
  static QString colorA, colorB;
};

#endif
