/***************************************************************************
                          varreader.h  -  description
                             -------------------
    begin                : ?' ??? 22 2002
    copyright            : (C) 2002 by Volker Nannen
    email                : volker@nannen.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef VARREADER_H
#define VARREADER_H

#include <qstring.h>
#include <qdialog.h>

class QLineEdit;
class QTextEdit;
class QRegExp;
class QRadioButton;
class QWidgetStack;
class QVBox;
class QTable;

class Points;

class VarReader : public QDialog {
  Q_OBJECT

public: 
  VarReader();
  ~VarReader();

public:
  bool load(Points * points);

private:
  void buildDialog();
  void makeRegex();
  void makeColumn();
  void makeEdit();

public slots:
  void readInput();
  void apply();
  void ok();
  void readPoints();
  void regexRadio();
  void columnRadio();
//  void editRadio();

private:
  enum RadioEnum{
    regex,
    column,
    edit
  };
  bool tableFilled;
  QRegExp * myRegExp, * xRegExp, * yRegExp;
  QString text, searchText;
  QWidgetStack * inputStack, * browserStack;
  QVBox * regexBox, * columnBox, * editBox;
  QLineEdit * xLine, * xCap, * yLine, * yCap, * splitLine, * xColumn, * yColumn;
  QTextEdit * browser;
  QTable * table;
  QRadioButton ** radioButtons;
  int xCapture, yCapture;
  Points * points;

  RadioEnum currentRadio;
};

//  some usefull regexes
//  ^(\D*\d+\.?\d*){1,4}\D*(\d+\.?\d*)
//  ^\D*(\d+\.?\d*)

#endif
